package ru.landgrafhomyak.serdha.api.v0.ddl

import ru.landgrafhomyak.serdha.api.v0.dml.Delete
import ru.landgrafhomyak.serdha.api.v0.dml.DeleteCreator
import ru.landgrafhomyak.serdha.api.v0.dml.Insert
import ru.landgrafhomyak.serdha.api.v0.dml.InsertCreator
import ru.landgrafhomyak.serdha.api.v0.dml.Select
import ru.landgrafhomyak.serdha.api.v0.dml.SelectCreator
import ru.landgrafhomyak.serdha.api.v0.dml.Update
import ru.landgrafhomyak.serdha.api.v0.dml.UpdateCreator

public interface ModuleModifyingRound {
	public fun interface CreateTable<TableUserWrapper : Any> {
		public fun createTable(creator: TableCreator<TableUserWrapper>): TableUserWrapper
	}

	public fun <TableUserWrapper : Any> createTable(namespace: Namespace, name: String, initializer: CreateTable<TableUserWrapper>): Table<TableUserWrapper, Nothing>

	public fun interface UpdateTable<TableNewUserWrapper : Any, TableOldUserWrapper : Any> {
		public fun updateTable(oldTable: Table<TableOldUserWrapper, *>, updater: TableUpdater<TableNewUserWrapper, TableOldUserWrapper>): TableNewUserWrapper
	}

	public fun <TableNewUserWrapper : Any, TableOldUserWrapper : Any> updateTable(
		oldTable: Table<TableOldUserWrapper, *>,
		initializer: UpdateTable<TableNewUserWrapper, TableOldUserWrapper>
	): Table<TableNewUserWrapper, TableOldUserWrapper>

	public fun <TableNewUserWrapper : Any, TableOldUserWrapper : Any> renameTable(
		table: Table<TableNewUserWrapper, TableOldUserWrapper>,
		newName: String
	): Table<TableNewUserWrapper, TableOldUserWrapper>

	public fun <TableNewUserWrapper : Any, TableOldUserWrapper : Any> renameTable(
		table: Table<TableNewUserWrapper, TableOldUserWrapper>,
		newNamespace: Namespace,
		newName: String
	): Table<TableNewUserWrapper, TableOldUserWrapper>

	public fun <TableNewUserWrapper : Any, TableOldUserWrapper : Any> updateAndRenameTable(
		table: Table<TableOldUserWrapper, *>,
		newName: String,
		initializer: UpdateTable<TableNewUserWrapper, TableOldUserWrapper>
	): Table<TableNewUserWrapper, TableOldUserWrapper>

	public fun <TableNewUserWrapper : Any, TableOldUserWrapper : Any> updateAndRenameTable(
		table: Table<TableNewUserWrapper, TableOldUserWrapper>,
		newNamespace: Namespace,
		newName: String,
		initializer: UpdateTable<TableNewUserWrapper, TableOldUserWrapper>
	): Table<TableNewUserWrapper, TableOldUserWrapper>

	public fun interface CreateSelect<QueryUserWrapper : Any> {
		public fun createSelect(creator: SelectCreator<QueryUserWrapper>): QueryUserWrapper
	}

	public fun <QueryUserWrapper : Any> createSelect(initializer: CreateSelect<QueryUserWrapper>): Select<QueryUserWrapper>

	public fun interface CreateInsert<TableUserWrapper : Any, QueryUserWrapper : Any> {
		public fun createInsert(table: Table<TableUserWrapper, *>, creator: InsertCreator<TableUserWrapper, QueryUserWrapper>): QueryUserWrapper
	}

	public fun <TableUserWrapper : Any, QueryUserWrapper : Any> createInsert(table: Table<TableUserWrapper, *>, initializer: CreateInsert<TableUserWrapper, QueryUserWrapper>): Insert<QueryUserWrapper>

	public fun interface CreateUpdate<TableUserWrapper : Any, QueryUserWrapper : Any> {
		public fun createUpdate(table: Table<TableUserWrapper, *>, creator: UpdateCreator<TableUserWrapper, QueryUserWrapper>): QueryUserWrapper
	}

	public fun <TableUserWrapper : Any, QueryUserWrapper : Any> createUpdate(table: Table<TableUserWrapper, *>, initializer: CreateUpdate<TableUserWrapper, QueryUserWrapper>): Update<QueryUserWrapper>

	public fun interface CreateDelete<TableUserWrapper : Any, QueryUserWrapper : Any> {
		public fun createDelete(table: Table<TableUserWrapper, *>, creator: DeleteCreator<TableUserWrapper, QueryUserWrapper>): QueryUserWrapper
	}

	public fun <TableUserWrapper : Any, QueryUserWrapper : Any> createDelete(table: Table<TableUserWrapper, *>, initializer: CreateDelete<TableUserWrapper, QueryUserWrapper>): Delete<QueryUserWrapper>

	public fun <W : Any> substituteModule(rootNs: Namespace, template: ModuleTemplate<W>): Module<W>
	public fun <W : Any> upgradeModule(oldModule: Module<*>, rootNs: Namespace, template: ModuleTemplate<W>): Module<W>
}