package ru.landgrafhomyak.serdha.api.v0.runtime

import ru.landgrafhomyak.serdha.api.v0.LowLevelApi
import ru.landgrafhomyak.serdha.api.v0.ddl.Module
import ru.landgrafhomyak.serdha.api.v0.dml.Delete
import ru.landgrafhomyak.serdha.api.v0.dml.Insert
import ru.landgrafhomyak.serdha.api.v0.dml.Select
import ru.landgrafhomyak.serdha.api.v0.dml.Update

public interface SynchronizedDatabase<W : Any> : Module<W> {
	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun _startTransaction(): Transaction

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserWrapper : Any> _startAutoTransactedSelect(query: Select<QueryUserWrapper>): _ParametersSetter<QueryUserWrapper, _ResultSet<QueryUserWrapper>>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserWrapper : Any> _startAutoTransactedInsert(query: Insert<QueryUserWrapper>): _ParametersSetter<QueryUserWrapper, _ResultSet<QueryUserWrapper>?>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserWrapper : Any> _startAutoTransactedUpdate(query: Update<QueryUserWrapper>): _ParametersSetter<QueryUserWrapper, _ResultSet<QueryUserWrapper>?>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserWrapper : Any> _startAutoTransactedDelete(query: Delete<QueryUserWrapper>): _ParametersSetter<QueryUserWrapper, _ResultSet<QueryUserWrapper>?>

	public interface AtomicScript<C, A, R> {
		public suspend fun executeTransaction(transaction: Transaction, context: C, args: A): R
	}

	public suspend fun <C, A, R> transaction(script: AtomicScript<C, A, R>, context: C, args: A): R

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun _close()
}